{
 "cells": [
  {
   "cell_type": "raw",
   "metadata": {
    "vscode": {
     "languageId": "raw"
    }
   },
   "source": [
    "---\n",
    "comments: true\n",
    "layout: post\n",
    "title: Data Types in Java 2\n",
    "type: collab \n",
    "courses: { csa: {week: 3} }\n",
    "ategories: [Java]\n",
    "author: James, Finn, Matty Danish, Justin\n",
    "---"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## SECTION 1.1\n",
    "\n",
    "## Why does java matter?\n",
    "\n",
    "one of the main reason that java is such an important language in the coding world is because it is a object-oriented-programming (OOP) language. \n",
    "\n",
    "It offers a structure that is easy to solve big problems, nut I think that we all know that, so let's skip to the real deal. \n",
    "\n",
    "\n",
    "## Basics of Java\n",
    "\n",
    "- Block Comments- The compiler will ignore any text between /* and */\n",
    "\n",
    "- Line comments- Same as above but // ignores one line\n",
    "\n",
    "- Class Declaration - identifies the name, the start and the end of the class. <b> the class name must match the file name. (case sensitive) </b>\n",
    "\n",
    "- `main` Method- controls all of the action in the program. \n",
    "\n",
    "- System.out- methods that print output to the console\n",
    "\n",
    "- System.out.print- prints what ever you out inside the ()\n",
    "\n",
    "- System.out.println- prints out input to the output and adds a newline to the end of it\n",
    "\n",
    "\n",
    "\n",
    "tip: add \"`<classname>.main(null)`\" at the end of your code to see the output in your jupyter notebook. "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "/* this is a\n",
    "   code block */\n",
    "\n",
    "\n",
    "// code: printing out hello world. \n",
    "\n",
    "public class greeting {\n",
    "    public static void main (String [] args) {\n",
    "        System.out.println(\"Hello, World!\");\n",
    "        System.out.print(\"Hello,\");\n",
    "        System.out.print(\" World!\"); \n",
    "    }\n",
    "}\n",
    "\n",
    "greeting.main(null)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## What is a string literal?\n",
    "\n",
    "- any sequence of letters, numbers, or symbols that is put between quotes. \n",
    "- Java will put out anything in the quotes, no restrictions. \n",
    "- If you would like to include a quote character in your literal, you must escape it with a backslash (e.g. `\"\\\"\"` would print `\"`)\n",
    "\n",
    "Examples: "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class stingLiterals {\n",
    "    public static void main (String[] args) {\n",
    "        System.out.println(\"This is a string literal.\");\n",
    "        System.out.println(\"and so are these\");\n",
    "        System.out.println(\"1234567890\"); \n",
    "        System.out.println(\"&^&*%^$&%$#^%W#*^$%&(*^)\"); \n",
    "        System.out.println(\"Escaped quotation mark: \\\"Hello!\\\"\")\n",
    "    }\n",
    "}\n",
    "\n",
    "stingLiterals.main(null)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Errors\n",
    "### Syntax/compiler error:\n",
    "\n",
    "- messed up syntax\n",
    "- compiler is not happy >:("
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [
    {
     "ename": "CompilationException",
     "evalue": "",
     "output_type": "error",
     "traceback": [
      "\u001b[1m\u001b[30m|   \u001b[1m\u001b[30m        System.out.println(\"This is a syntax error.\")\u001b[0m\u001b[1m\u001b[30m\u001b[41m\u001b[0m\u001b[1m\u001b[30m\u001b[0m",
      "\u001b[1m\u001b[31m';' expected\u001b[0m",
      ""
     ]
    }
   ],
   "source": [
    "\n",
    "public class syntaxError {\n",
    "    public static void main (String[] args) {\n",
    "        System.out.println(\"This is a syntax error.\")\n",
    "        //missing semicolon\n",
    "    }\n",
    "}\n",
    "\n",
    "syntaxError.main(null)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Logic Error\n",
    "\n",
    "- compiler is happy (no error during compilation)\n",
    "- messed up in the string literals (you typed something wrong)\n",
    "- code runs fine, but has an unexpected output"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "This is a leogic error.\n"
     ]
    }
   ],
   "source": [
    "public class logicError {\n",
    "    public static void main (String[] args) {\n",
    "        System.out.println(\"This is a leogic error.\");\n",
    "    }\n",
    "}\n",
    "\n",
    "logicError.main(null)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Exception error: \n",
    "- Your program compiles fine\n",
    "- Happens at runtime\n",
    "- For example: number is divided by zero"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "java.lang.ArithmeticException: / by zero\n",
      "\tat REPL.$JShell$20$exceptionError.main($JShell$20.java:19)\n",
      "\tat REPL.$JShell$21.do_it$($JShell$21.java:16)\n",
      "\tat java.base/jdk.internal.reflect.DirectMethodHandleAccessor.invoke(DirectMethodHandleAccessor.java:104)\n",
      "\tat java.base/java.lang.reflect.Method.invoke(Method.java:578)\n",
      "\tat io.github.spencerpark.ijava.execution.IJavaExecutionControl.lambda$execute$1(IJavaExecutionControl.java:95)\n",
      "\tat java.base/java.util.concurrent.FutureTask.run(FutureTask.java:317)\n",
      "\tat java.base/java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1144)\n",
      "\tat java.base/java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:642)\n",
      "\tat java.base/java.lang.Thread.run(Thread.java:1623)\n"
     ]
    }
   ],
   "source": [
    "public class exceptionError {\n",
    "    public static void main(String[] args) {\n",
    "        try {\n",
    "            int result = 2 / 0;\n",
    "            System.out.println(\"Result: \" + result);\n",
    "        } catch (ArithmeticException e) {  //this just makes the error more verbose\n",
    "            e.printStackTrace();\n",
    "        }\n",
    "    }\n",
    "}\n",
    "exceptionError.main(null)\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "______\n",
    "\n",
    "# SECTION 1.2\n",
    "## Variable and Data Types.  \n",
    "\n",
    "## Primitive Data\n",
    "- determines the size and type of data can we can worth with in a java program. \n",
    "- focus on three different types that can we can represent data. \n",
    "\n",
    "\n",
    "#### Smallest to biggest:\n",
    "\n",
    "Boolean, takes up 1 bit. \n",
    "- true or false\n",
    "\n",
    "\n",
    "Int, take up 32 bit\n",
    "- whole number values.\n",
    "- add, subtract, multiply, etc. \n",
    "\n",
    "Doubles, AKA Floating point numbers. 64 bit\n",
    "- same as integers\n",
    "\n",
    "String\n",
    "- \"Hello World!\"\n",
    "\n",
    "\n",
    "\n",
    "Reference Purposes\n",
    "\n",
    "(the collegeboard person used bows as reference so will i.)\n",
    "- there can be small bow\n",
    "- a medium bow\n",
    "- a red bow\n",
    "- a large red bow\n",
    "\n",
    "\n",
    "\n",
    "### What is the difference?\n",
    "\n",
    "- primitive data are already in java, you don't have to make it. Except for string, which is created by the programmer. \n",
    "- non-primitive data can be use methods to perform actions, but primitive data cannot. \n",
    "\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\n",
    "## Primitive Activity\n",
    "#### MIX&MATCH\n",
    "\n",
    "\n",
    "```\n",
    "Choices:\n",
    "1. int\n",
    "2. double\n",
    "3. boolean\n",
    "4. String\n",
    "\n",
    "\n",
    "\n",
    "__ False\n",
    "\n",
    "__ \"ryan gosling\"\n",
    "\n",
    "__ 1738\n",
    "\n",
    "__ 4.26\n",
    "```\n",
    "\n",
    "#### Questions:\n",
    "\n",
    "what type of data should be used to store\n",
    "\n",
    "- someones bank number and cvc?\n",
    "\n",
    "- someones mother's maiden name and their name?\n",
    "\n",
    "- the first 16 digits of pi\n",
    "\n",
    "- if you want to transact one million $. \n",
    "\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Variables\n",
    "\n",
    "A name given to a memory location that is holding a specified type of value.\n",
    "\n",
    "### how to name a variable (omg this is so hard !)\n",
    "\n",
    "- may consists of letters, digits, or an underscore (case sensitive)\n",
    "\n",
    "- may not start with a digit\n",
    "- space are a big no no\n",
    "- may not use other characters as &,@, or #\n",
    "- may not used java reserved words\n",
    "\n",
    "\n",
    "#### Tip!\n",
    "\n",
    "use camel casing when naming a variables. This is a Java convention (it may be different for other programming languages)\n",
    "\n",
    "#### example: \n",
    "\n",
    "thisIsCamelCasing\n",
    "\n",
    "\n",
    "\n",
    "### Declare variables:\n",
    "\n",
    "The three primitiva data types in Java:\n",
    "- integers (whole #): `int`\n",
    "- Decimal numbers (floating-point values): `double`\n",
    "- Boolean values (true/false): `boolean`\n",
    "\n",
    "\n",
    "#### Format:\n",
    "\n",
    "dataType varibleName;\n",
    "\n",
    "#### Example\n",
    "\n",
    "`int total;`\n",
    "\n",
    "`boolean outcome;`\n",
    "\n",
    "`double firstFifteenPi;`\n",
    "\n",
    "\n",
    "### what if you don't want to change the variable's value after given?\n",
    "\n",
    "- Usually used for constants\n",
    "    - Constants are just numbers that have a fixed and known value, such as pi in match\n",
    "\n",
    "add final in front of the declaration:\n",
    "\n",
    "`final double PI;`\n",
    "\n",
    "`final boolean WORKOUT_DECISION; `\n",
    "\n",
    "for `final`` variables, use all caps and underscores when naming them. This is also known as \"screaming snake case\".\n",
    "\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Practice\n",
    "\n",
    "### Find the odd ones out (hint: there are 5).\n",
    "\n",
    "\n",
    "int value; \n",
    "\n",
    "double 4eva;\n",
    "\n",
    "boolean private;\n",
    "\n",
    "integer sum;\n",
    "\n",
    "double wow!; \n",
    "\n",
    "boolean foundIt; \n",
    "\n",
    "int numberOfStudents; \n",
    "\n",
    "double chanceOfRain;\n",
    "\n",
    "boolean #mortNews;\n",
    "\n",
    "int count;\n",
    "\n",
    "bool isFriday; \n",
    "\n",
    "final int DOZEN;\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "___\n",
    "\n",
    "## 1.3 Main Topics\n",
    "### Literal vs String Literal\n",
    "\n",
    "### Arithmetic operators\n",
    "- Additon\n",
    "- Minus\n",
    "- Multiply\n",
    "- Divide\n",
    "- Mod\n",
    "\n",
    "### Arthemtic expressions\n",
    "- Int\n",
    "- Double\n",
    "    \n",
    "### Assigment Operator\n",
    "- = vs ==\n",
    "\n",
    "# Demo 1"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class demo {\n",
    "    public static void main(String[] args) {\n",
    "        // Whats is the outputs between these two pieces of code\n",
    "        //\n",
    "        //\n",
    "        //\n",
    "        \n",
    "        /* \n",
    "        System.out.println(\"3\" + \"3\");\n",
    "        System.out.println(3 / 2);\n",
    "        System.out.println(2.0 * 1.5);\n",
    "        */\n",
    "    }\n",
    "}\n",
    "\n",
    "demo.main(null);"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Cheat Sheet\n",
    "\n",
    "## Literal\n",
    "- The source code representation of a fixed value\n",
    "\n",
    "## String Literal\n",
    "- Something enclosed in double qoutes\n",
    "\n",
    "\n",
    "## Assigment Operator\n",
    "- = is an assigment operator: assign a variable name to a value\n",
    "- == is repesents just normal =: use it to test the equality of two variables\n",
    "- Assigment Operators movs left to right: <name> = <value>\n",
    "- X = Y = Z = 2;\n",
    "- Why is 7 = x; a non valid peice of code\n",
    "- \n",
    "\n",
    "## PEMDAS\n",
    "- Java uses PEMDAS still but a tiny bit different\n",
    "\n",
    "### Order\n",
    "1. ()\n",
    "2. *, /, %\n",
    "3. +, -\n",
    "\n",
    "## Primative Data Types\n",
    "[table](http://orion.towson.edu/~izimand/237/LectureNotes/L3-PrimitiveDataTypes.JPG)\n",
    "\n",
    "## Operation vs Result\n",
    "- The bigger data type will always be the resulting output\n",
    "- If you were to add a double and a int what would be the result?\n",
    "- \n",
    "\n",
    "# Demo 2"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class Demo2 {\n",
    "    public static void main(String[] args) {\n",
    "        // Print a math equation that goes through these steps\n",
    "        // Adds 19 + 134\n",
    "        // Multiplies that value by 5\n",
    "        // Then takes the mod of that value by 2\n",
    "        // It should print 1\n",
    "\n",
    "        System.out.println( \"add something here!\");\n",
    "    }\n",
    "}\n",
    "\n",
    "Demo2.main(null);"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Odd Even"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class OddEven {\n",
    "\n",
    "    // Without changing any variables,\n",
    "    // Adjust the code such that it only prints odd numbers\n",
    "    \n",
    "    public static void main(String[] args) {\n",
    "        int num = 2;\n",
    "        int i = 0;\n",
    "        while (i <= 10) {\n",
    "            if (i % num == 0) {\n",
    "                System.out.println(i + \" is even\");\n",
    "            }\n",
    "            i++;\n",
    "        }\n",
    "    }\n",
    "}\n",
    "\n",
    "OddEven.main(null);"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# 1.4"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Compound Assignment Operators\n",
    "\n",
    "look at storing items in variables with assignment statemt.\n",
    "\n",
    "also look at compound assignment operators (+=, -= etc) to modify values stored in variables in one step\n",
    "\n",
    "+= adds value to existing variable value\n",
    "\n",
    "x += 7 is equivalent to x = x + 7;\n",
    "x -= 5 is equivalent to x = x - 5;\n",
    "\n",
    "same for all compound assignment operators.\n",
    "\n",
    "# also learn how to trace through code (check comments of codeblock below)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class CompoundDemo {\n",
    "    public static void main(String[] args) {\n",
    "        int x = 6;\n",
    "        x += 7; // 6 + 7 = 13\n",
    "        x -= 3; // 13 - 3 = 10\n",
    "        System.out.println(x);\n",
    "        x *= 10; // 10 * 10\n",
    "        x /= 5; // 100 / 5 = 20\n",
    "        System.out.println(x);\n",
    "        x %= 3; // remainder of 100/3 = 2\n",
    "        System.out.println(x);\n",
    "}\n",
    "}\n",
    "CompoundDemo.main(null);\n",
    "\n",
    "// NOTE: going through these compound assignments with comments is called tracing,\n",
    "// when we do what the compiler does, and go through the code step by step. Should be\n",
    "//done on the AP test to avoid human error."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# increment and decrement operator\n",
    "\n",
    "IMPORTANT: THE USE OF INCREMENT AND DECREMENT OPERATORS IN THE PREFIX FORM (++X) AND INSIDE OTHER EXPRESSIONS (ARR[X++]) IS OUTSIDE THE SCOPE OF THE COURSE AND THE AP EXAM"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class incdecDemo {\n",
    "    public static void main(String[] args) {\n",
    "    int x = 1; \n",
    "    int y = 1;\n",
    "    x++; // x = x + 1, x = 2;\n",
    "    y--; // y = y - 1, y = 1 - 1 = 1;\n",
    "    System.out.println(x);\n",
    "    System.out.println(y);\n",
    "}\n",
    "}\n",
    "incdecDemo.main(null);\n",
    "\n",
    "// NOTE: going through these compound assignments in order is important to\n",
    "// ensure you get the correct output at the end"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# learn how to describe code \n",
    "\n",
    "the following code segment has comments that describe the line of code the comment is on. Look at how the code is described."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class behaviorDemo {\n",
    "    public static void main(String[] args) {\n",
    "    int x = 20; // define an int variable x and set its initial value to 23\n",
    "    x *= 2; // take the current value of x, multiply it by 2, assign the result back to x\n",
    "    x %= 10; // take the current value of x, find x modulus 10 (remainder x divided by 10), \n",
    "    //assign result back to x\n",
    "    System.out.println(x); // display the current value of x\n",
    "}\n",
    "}\n",
    "behaviorDemoDemo.main(null); "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# practice important concepts"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class numbers {\n",
    "    public static void main(String[] args) {\n",
    "        int x = 777;\n",
    "\n",
    "        // challenge: use 2 compound assignment operators to turn the current value of x\n",
    "        // into the value in the comment. print it at each step. for example, to change\n",
    "        // the value to 1400:\n",
    "        // x -= 77;\n",
    "        // x *= 2;\n",
    "\n",
    "        // 100?\n",
    "\n",
    "        // 779?\n",
    "\n",
    "        // 2?\n",
    "\n",
    "        System.out.println(x);\n",
    "}\n",
    "}\n",
    "CompoundDemo.main(null);"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "// PRACTICE TRACING THROUGH THE FOLLOWING CODE (someone could come up and do it on a whiteboard if we have time for fun)\n",
    "// comment the value of x after each statement\n",
    "\n",
    "public class Demo {\n",
    "    public static void main(String[] args) {\n",
    "        int x = 758; // x = 758\n",
    "        x += 423; // x = ...\n",
    "        x -= 137; \n",
    "        x *= 99; \n",
    "        x /= 33; \n",
    "        x %= 111; \n",
    "        System.out.println(x);\n",
    "}\n",
    "}\n",
    "CompoundDemo.main(null);\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "// DESCRIBE EACH LINE OF CODE in a comment after each statement\n",
    "int x = 5; \n",
    "x++;\n",
    "x /= 2;\n",
    "System.out.println(x);"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# what you must know \n",
    "\n",
    "compound operators perform an operation on a variable and assign the result to the variable\n",
    "\n",
    "ex: x /= 25; would take x and divide it by 25, then assign the result to x.\n",
    "\n",
    "if x = 100, then the result of x/= 25; would be x=4.\n",
    "\n",
    "increment and decrement operators take x and either increment it or decrement it by 1, then assign the value to x.\n",
    "\n",
    "x++; would take x and add 1 to it, then assign the value to x.\n",
    "\n",
    "x--; takes x and subtracts 1 from x, then assigns the value to x.\n",
    "\n",
    "### your frq will likely see if you know how to use compound operators in actual code.\n",
    "\n",
    "# mini hacks:\n",
    "\n",
    "1. write some java code that uses compound operators and then trace through it similarly to the examples shown in this lesson. Use conditional statements as well, don't just execute some compound operators on an x value in order and call it a day. You might have to do tracing on the AP test so this is for your own good.\n",
    "\n",
    "# example below"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class CompoundAssignment {\n",
    "\n",
    "    public static void main(String[] args) {\n",
    "      \n",
    "      int sum = 0; \n",
    "      for (int i = 0; i < 2; i++) {  // i = i + 1 each iteration, 1st iteration i = 0\n",
    "        for (int j = 0; j < 2; j++) { // j = j + 1 each iteration, 1st iteration j = 0\n",
    "          System.out.println(\"i: \" + i);\n",
    "          System.out.println(\"j: \" + j);\n",
    "          sum += i + j; //  sum = sum + (i + j) each iteration, 1st iteration sum = 0 + (0 + 0)\n",
    "          System.out.println(sum);\n",
    "\n",
    "        }\n",
    "      }\n",
    "      \n",
    "      System.out.println(\"Sum: \" + sum);\n",
    "  \n",
    "  } }\n",
    "CompoundAssignment.main(null);"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# 1.5"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<html>\n",
    "<head>\n",
    "<style>\n",
    "    @import url('https://fonts.googleapis.com/css?family=Arima+Madurai:300');\n",
    "    *,\n",
    "    *::before,\n",
    "    *::after {\n",
    "        box-sizing: border-box;\n",
    "    }\n",
    "    .bird {\n",
    "        background-image: url(https://s3-us-west-2.amazonaws.com/s.cdpn.io/174479/bird-cells-new.svg);\n",
    "        background-size: auto 100%;\n",
    "        width: 88px;\n",
    "        height: 125px;\n",
    "        will-change: background-position;\n",
    "        animation-name: fly-cycle;\n",
    "        animation-timing-function: steps(10);\n",
    "        animation-iteration-count: infinite;\n",
    "        &--one {\n",
    "            animation-duration: 1s;\n",
    "            animation-delay: -0.5s;\t\t\n",
    "        }\n",
    "        &--two {\n",
    "            animation-duration: 0.9s;\n",
    "            animation-delay: -0.75s;\n",
    "        }\n",
    "        &--three {\n",
    "            animation-duration: 1.25s;\n",
    "            animation-delay: -0.25s;\n",
    "        }\n",
    "        &--four {\n",
    "            animation-duration: 1.1s;\n",
    "            animation-delay: -0.5s;\n",
    "        }\n",
    "    }\n",
    "    .bird-container {\n",
    "        top: 20%;\n",
    "        left: -10%;\n",
    "        transform: scale(0) translateX(-10vw);\n",
    "        will-change: transform;\n",
    "        animation-name: fly-right-one;\n",
    "        animation-timing-function: linear;\n",
    "        animation-iteration-count: infinite;\n",
    "        &--one {\n",
    "            animation-duration: 15s;\n",
    "            animation-delay: 0;\n",
    "        }\n",
    "        &--two {\n",
    "            animation-duration: 16s;\n",
    "            animation-delay: 1s;\n",
    "        }      \n",
    "        &--three {\n",
    "            animation-duration: 14.6s;\n",
    "            animation-delay: 9.5s;\n",
    "        }\n",
    "        &--four {\n",
    "            animation-duration: 16s;\n",
    "            animation-delay: 10.25s;\n",
    "        }\n",
    "    }\n",
    "    @keyframes fly-cycle {\n",
    "        100% {\n",
    "            background-position: -900px 0;\n",
    "        } \n",
    "    }\n",
    "    @keyframes fly-right-one {\n",
    "        0% {\n",
    "            transform: scale(0.3) translateX(-10vw);\n",
    "        }\n",
    "        10% {\n",
    "            transform: translateY(2vh) translateX(10vw) scale(0.4);\n",
    "        }\n",
    "        20% {\n",
    "            transform: translateY(0vh) translateX(30vw) scale(0.5);\n",
    "        }        \n",
    "        30% {\n",
    "            transform: translateY(4vh) translateX(50vw) scale(0.6);\n",
    "        }        \n",
    "        40% {\n",
    "            transform: translateY(2vh) translateX(70vw) scale(0.6);\n",
    "        }       \n",
    "        50% {\n",
    "            transform: translateY(0vh) translateX(90vw) scale(0.6);\n",
    "        }        \n",
    "        60% {\n",
    "            transform: translateY(0vh) translateX(110vw) scale(0.6);\n",
    "        }        \n",
    "        100% {\n",
    "            transform: translateY(0vh) translateX(110vw) scale(0.6);\n",
    "        }       \n",
    "    }\n",
    "    @keyframes fly-right-two {  \n",
    "        0% {\n",
    "            transform: translateY(-2vh) translateX(-10vw) scale(0.5);\n",
    "        }        \n",
    "        10% {\n",
    "            transform: translateY(0vh) translateX(10vw) scale(0.4);\n",
    "        }       \n",
    "        20% {\n",
    "            transform: translateY(-4vh) translateX(30vw) scale(0.6);\n",
    "        }        \n",
    "        30% {\n",
    "            transform: translateY(1vh) translateX(50vw) scale(0.45);\n",
    "        }        \n",
    "        40% {\n",
    "            transform: translateY(-2.5vh) translateX(70vw) scale(0.5);\n",
    "        }        \n",
    "        50% {\n",
    "            transform: translateY(0vh) translateX(90vw) scale(0.45);\n",
    "        }     \n",
    "        51% {\n",
    "            transform: translateY(0vh) translateX(110vw) scale(0.45);\n",
    "        }     \n",
    "        100% {\n",
    "            transform: translateY(0vh) translateX(110vw) scale(0.45);\n",
    "        }     \n",
    "    }\n",
    "\n",
    "</style>\n",
    "</head>\n",
    "\t<div class=\"bird-container bird-container--one\">\n",
    "\t\t<div class=\"bird bird--one\"></div>\n",
    "\t</div>\n",
    "\t<div class=\"bird-container bird-container--two\">\n",
    "\t\t<div class=\"bird bird--two\"></div>\n",
    "\t</div>\n",
    "\t<div class=\"bird-container bird-container--three\">\n",
    "\t\t<div class=\"bird bird--three\"></div>\n",
    "\t</div>\n",
    "\t<div class=\"bird-container bird-container--four\">\n",
    "\t\t<div class=\"bird bird--four\"></div>\n",
    "\t</div>\n",
    "\n",
    "</html>\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Casting Variable \n",
    "<style>\n",
    ".flip-card-container {\n",
    "  width: 800px;\n",
    "  height: 200px;\n",
    "  perspective: 1000px;\n",
    "}\n",
    ".flip-card {\n",
    "  position: relative;\n",
    "  width: 100%;\n",
    "  height: 100%;\n",
    "  transition: transform 1s;\n",
    "  transform-style: preserve-3d;\n",
    "}\n",
    ".flip-card-container:hover .flip-card {\n",
    "  transform: rotateY(180deg); /* <=>  rotateY(.5turn) */\n",
    "}\n",
    "/* Position the front and back side */\n",
    ".flip-card-front, .flip-card-back {\n",
    "  position: absolute;\n",
    "  width: 100%;\n",
    "  height: 100%;\n",
    "  -webkit-backface-visibility: hidden; /* Safari */\n",
    "  backface-visibility: hidden;\n",
    "  display: flex;\n",
    "  justify-content: center;\n",
    "  align-items: center;\n",
    "  /* border-radius: 0.5rem; */\n",
    "}\n",
    ".flip-card-front {\n",
    "  background-color:#DC78BB;\n",
    "  color: #fff;\n",
    "}\n",
    ".flip-card-back {\n",
    "  background-color: #517fa4;\n",
    "  color: #fff;\n",
    "  transform: rotateY(180deg);\n",
    "}\n",
    ".flip-card-front p {\n",
    "  text-align: center;\n",
    "  margin: 1rem;\n",
    "  font-size: 1.4rem;\n",
    "  line-height: 1.5rem;\n",
    "}\n",
    ".flip-card-back p {\n",
    "  text-align: center;\n",
    "  margin: 1rem;\n",
    "  font-size: 1.4rem;\n",
    "  line-height: 1.5rem;\n",
    "}\n",
    ".flip-card-back p span {\n",
    "  display: block;\n",
    "  font-size: 1rem;\n",
    "  font-style: italic;\n",
    "  font-weight: bold;\n",
    "  margin-top: 1.25rem;\n",
    "}\n",
    "</style>\n",
    "  <div class=\"flip-card-container\">\n",
    "    <div class=\"flip-card\">\n",
    "      <div class=\"flip-card-front\">\n",
    "        <p>CASTING</p>\n",
    "      </div>\n",
    "      <div class=\"flip-card-back\">\n",
    "        <p>\n",
    "          \"Change the data type of variable from one type to another.\"\n",
    "        </p>\n",
    "      </div>\n",
    "    </div>\n",
    "  </div>"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "### Example\n",
    "- Int variable ---->> double\n",
    "- String variable ---->> Int"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "/*\n",
    "* Purpose: Demonstrate casting using division.\n",
    "*/\n",
    "public class CastingNumbers {\n",
    "    public static void main(String[] args) {\n",
    "        System.out.println(6 / 4); // if I just do divide 6 by 4, these are both int value, so I'm going to wing up with an int result.\n",
    "        System.out.println (6.0 / 4); // Since one of those value is a double value, output will be double \n",
    "        System.out.println(6 / 4.0); // (Same Reason) I wind up with the result of 1.5\n",
    "    }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "\n",
    "<style>\n",
    ".navbar {\n",
    "    /* background-color: #333; */\n",
    "    position: relative;\n",
    "    z-index: 999;\n",
    "}\n",
    ".navbar ul {\n",
    "    list-style-type: none;\n",
    "    margin: 0;\n",
    "    padding: 0;\n",
    "}\n",
    ".navbar li {\n",
    "    display: inline-block;\n",
    "}\n",
    ".navbar li a {\n",
    "color: gray;\n",
    "display: block;\n",
    "padding: 10px 20px;\n",
    "background-color: black;\n",
    "}\n",
    ".navbar ul ul {\n",
    "position: absolute;\n",
    "top: 100%;\n",
    "display: none;\n",
    "}\n",
    ".navbar ul ul li {\n",
    "display: block;\n",
    "}\n",
    ".navbar ul ul li a:hover {\n",
    "background-color: #555;\n",
    "}\n",
    ".navbar li:hover ul {\n",
    "display: block;\n",
    "}\n",
    "\n",
    "</style>\n",
    "<nav class=\"navbar\">\n",
    "<ul>\n",
    "<li>\n",
    "  <a href=\"#\">What will be the answer of System.out.println((double) 6/4);</a>\n",
    "    <ul>\n",
    "      <li><a href=\"#\">By using the casting operator of double in parentheses, it will still wind up with a double result of 1.5.</a></li>\n",
    "    </ul>\n",
    "</li>\n",
    "</ul>\n",
    "</nav>"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Ranges of variable\n",
    "int: Stored by using a finite amount (4 bytes) of memory.\n",
    "<img src=\"https://drive.google.com/uc?export=download&id=1i3lnzVrOeIaRPSWsOntErVGiKToL0Keh\">\n",
    "\n",
    "### Integer\n",
    "Max: 2,147,483,647     \n",
    "Min: -2,147,483,648\n",
    "\n",
    "### Double \n",
    "up to 14 - 15 digits for storage\n",
    "\n",
    "### Boolean \n",
    "only 2 (true and false)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "/*\n",
    "* Purpose: Demonstrate Integer Range\n",
    "*/\n",
    "public class TooBigNumber {\n",
    "    public static void main(String[] args) {\n",
    "        int posInt = 2147483647; \n",
    "        int negInt = -2147483648;\n",
    "        System.out.println(posInt + \" \"); \n",
    "        System.out.println(negInt);\n",
    "    }\n",
    "}\n",
    "TooBigNumber.main(null);"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "/*\n",
    "* Purpose: Demonstrate Integer.MAX_VALUE and Integer.MIN_VALUE.\n",
    "*/\n",
    "public class IntMinMax {\n",
    "    public static void main(String[] args) {\n",
    "        int posInt = Integer.MAX_VALUE; \n",
    "        int negInt = Integer.MIN_VALUE;\n",
    "        System.out.println(posInt + \" \"); \n",
    "        System.out.println(negInt);\n",
    "    }\n",
    "}\n",
    "IntMinMax.main(null);"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "/*\n",
    "* Purpose: Demonstrate Integer Overflow\n",
    "*/\n",
    "public class TooBigNumber {\n",
    "    public static void main(String[] args) {\n",
    "        int posInt = Integer.MAX_VALUE; \n",
    "        int negInt = Integer.MIN_VALUE;\n",
    "        // overflows/wraps to opposite sign\n",
    "        // basically produces nonsense\n",
    "        System.out.println(posInt + 1); \n",
    "        System.out.println(negInt - 1);\n",
    "    }\n",
    "}\n",
    "TooBigNumber.main(null);"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "import java.util.Scanner;\n",
    "\n",
    "public class Sum_forABC {\n",
    "\tpublic static void main(String args[]) {\n",
    "\t\tint a = 70;\n",
    "\t\tint b = 63;\n",
    "\t\tint c = 82;\n",
    "\t\t\n",
    "\t\tint total = a + b + c;\n",
    "        \n",
    "\t\tdouble avg = total / 3; \n",
    "\t\t\n",
    "\t\t// note: \\t means \"tab\", which usually prints out the equivalent\n",
    "\t\t// of 4 spaces\n",
    "\t\tSystem.out.println(\"a\\tb\\tc\");\n",
    "\t\tSystem.out.println(a+\"\\t\"+b+\"\\t\"+c);\n",
    "\t\tSystem.out.println(\"total:\" + total);\n",
    "\t\tSystem.out.printf(\"average: %.2f\", avg);\n",
    "\t}\n",
    "}\n",
    "Sum_forABC.main(null);"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<!DOCTYPE html>\n",
    "<html>\n",
    "<head>\n",
    "    <title>Java Code Runner</title>\n",
    "    <style>\n",
    "    textarea {\n",
    "        font-size: 19px;\n",
    "        margin: 1.5rem 0px;\n",
    "        border: none;\n",
    "        outline: none;\n",
    "        background-color: #eeeeff;\n",
    "    }\n",
    "    .w-btn {\n",
    "        position: relative;\n",
    "        border: none;\n",
    "        display: inline-block;\n",
    "        padding: 15px 30px;\n",
    "        border-radius: 15px;\n",
    "        font-family: \"paybooc-Light\", sans-serif;\n",
    "        box-shadow: 0 15px 35px rgba(0, 0, 0, 0.2);\n",
    "        text-decoration: none;\n",
    "        font-weight: 600;\n",
    "        transition: 0.25s;\n",
    "    }\n",
    "    .w-btn-gra3 {\n",
    "        background: linear-gradient(\n",
    "            45deg,\n",
    "            #ff0000,\n",
    "            #ff7300,\n",
    "            #fffb00,\n",
    "            #48ff00,\n",
    "            #00ffd5,\n",
    "            #002bff,\n",
    "            #7a00ff,\n",
    "            #ff00c8,\n",
    "            #ff0000\n",
    "        );\n",
    "        color: white;\n",
    "    }\n",
    "    .w-btn-gra-anim {\n",
    "        background-size: 400% 400%;\n",
    "        animation: gradient1 5s ease infinite;\n",
    "    }\n",
    "    @keyframes gradient1 {\n",
    "        0% {\n",
    "            background-position: 0% 50%;\n",
    "        }\n",
    "        50% {\n",
    "            background-position: 100% 50%;\n",
    "        }\n",
    "        100% {\n",
    "            background-position: 0% 50%;\n",
    "        }\n",
    "    }\n",
    "</style>\n",
    "</head>\n",
    "<body>\n",
    "    <textarea id=\"code\" rows = \"13\" cols=\"96\">\n",
    "/*\n",
    "Long: 64-bit two's complement integer\n",
    "*/\n",
    "public class sum {\n",
    "    public static void main(String args[]) {\n",
    "        int x = 100000;\n",
    "        int y = 200000;\n",
    "                    \n",
    "        long z = x * y; \n",
    "        System.out.println(z);\n",
    "    }\n",
    "}\n",
    "</textarea>\n",
    "<div id=\"codeResult\"></div>\n",
    "<button class=\"w-btn w-btn-gra3 w-btn-gra-anim\" onclick =\"codeRun()\">Run Code</button>\n",
    "<script>\n",
    "        async function codeRun() {\n",
    "            const javaCode = document.getElementById('code').value;\n",
    "            const data = new URLSearchParams({\n",
    "                'code': javaCode,\n",
    "                'language': 'java', // Changed language to Java\n",
    "                'input': '' // You can add input if needed\n",
    "            });\n",
    "            const url = 'https://api.codex.jaagrav.in'; // Added missing URL declaration\n",
    "            const options = {\n",
    "                method: 'post',\n",
    "                headers: {\n",
    "                    'Content-Type': 'application/x-www-form-urlencoded'\n",
    "                },\n",
    "                body: data.toString() // Changed to data.toString()\n",
    "            };\n",
    "            try {\n",
    "                const response = await fetch(url, options);\n",
    "                const result = await response.json();\n",
    "                document.getElementById('codeResult').innerHTML = `<textarea cols=\"96\">${result.output}</textarea>`;\n",
    "            } catch (error) {\n",
    "                console.error(error);\n",
    "            }\n",
    "        }\n",
    "    </script>\n",
    "</body>\n",
    "</html>"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "<html>\n",
    "\n",
    "<head>\n",
    "    <meta charset=\"UTF-8\">\n",
    "</head>\n",
    "\n",
    "<body>\n",
    "    <h1>Questions</h1>\n",
    "    <p>1. what will be the output of (int) (2.5 * 3.0)</p>\n",
    "    <form name=\"form1\">\n",
    "        <input type=\"radio\" name=\"answer1\" value=\"1\">7.0<br>\n",
    "        <input type=\"radio\" name=\"answer1\" value=\"2\">7<br>\n",
    "        <input type=\"radio\" name=\"answer1\" value=\"3\">7.5<br>\n",
    "        <input type=\"radio\" name=\"answer1\" value=\"4\">7.50<br>\n",
    "    </form>\n",
    "    <p id=\"check1\"></p>\n",
    "    <p>2. what will be the output of (double) 25 / 4</p>\n",
    "    <form name=\"form2\">\n",
    "        <input type=\"radio\" name=\"answer2\" value=\"1\">6.50<br>\n",
    "        <input type=\"radio\" name=\"answer2\" value=\"2\">6.0<br>\n",
    "        <input type=\"radio\" name=\"answer2\" value=\"3\">6<br>\n",
    "        <input type=\"radio\" name=\"answer2\" value=\"4\">6.25<br>\n",
    "    </form>\n",
    "    <p id=\"check2\"></p>\n",
    "    <p>3. what will be the output of 6 / (double) 5</p>\n",
    "    <form name=\"form3\">\n",
    "        <input type=\"radio\" name=\"answer3\" value=\"1\">1.0<br>\n",
    "        <input type=\"radio\" name=\"answer3\" value=\"2\">1<br>\n",
    "        <input type=\"radio\" name=\"answer3\" value=\"3\">1.2<br>\n",
    "        <input type=\"radio\" name=\"answer3\" value=\"4\">1.125<br>\n",
    "    </form>\n",
    "    <p id=\"check3\"></p>\n",
    "    <p>4. what will be the output of (int) (-8.63 -  0.5)</p>\n",
    "    <form name=\"form4\">\n",
    "        <input type=\"radio\" name=\"answer4\" value=\"1\">-9<br>\n",
    "        <input type=\"radio\" name=\"answer4\" value=\"2\">-13.63<br>\n",
    "        <input type=\"radio\" name=\"answer4\" value=\"3\">-9.13<br>\n",
    "        <input type=\"radio\" name=\"answer4\" value=\"4\">-8<br>\n",
    "    </form>\n",
    "    <p id=\"check4\"></p>\n",
    "    <input type=\"button\" name=\"select\" value=\"check your answer\" onclick=\"myFunction()\">\n",
    "    <script type=\"text/javascript\">\n",
    "        function myFunction() {\n",
    "            checkAnswer(1, \"answer1\", \"check1\", 2);\n",
    "            checkAnswer(2, \"answer2\", \"check2\", 4);\n",
    "            checkAnswer(3, \"answer3\", \"check3\", 3);\n",
    "            checkAnswer(4, \"answer4\", \"check4\", 1);\n",
    "        }\n",
    "        function checkAnswer(questionNumber, answerName, checkId, correctAnswer) {\n",
    "            var selectedAnswer = document.querySelector('input[name=\"' + answerName + '\"]:checked');\n",
    "            if (selectedAnswer) {\n",
    "                if (parseInt(selectedAnswer.value) === correctAnswer) {\n",
    "                    document.getElementById(checkId).innerHTML = \"correct!\";\n",
    "                } else {\n",
    "                    document.getElementById(checkId).innerHTML = \"wrong\";\n",
    "                }\n",
    "            } else {\n",
    "                document.getElementById(checkId).innerHTML = \"Please select an answer for question \" + questionNumber + \".\";\n",
    "            }\n",
    "        }\n",
    "    </script>\n",
    "</body>\n",
    "\n",
    "</html>"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Essential Knowledge (2.B)\n",
    "1. The casting operators (int) and (double) can be used to created temporary value converted into a different data type. \n",
    "2. Casting a double value to an int causes the digits to the right of the decimal point to be truncated. \n",
    "3. Some programming code causes int values to be automatically cast(widened) to double values.\n",
    "4. Value of type double can be rounded to the nearest integer (int) (x + 0.5) + (int) (x - 0.5) for negative numbers.\n"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Essential Knowledge (5.B)\n",
    "1. Integer values in Java are represented by values of type int, which are stored using a finite amount (4 bytes) of memory. Therefore, an int value must be in the range from\n",
    "Integer.MIN_VALUE to Integer.MAX_VALUE inclusive.\n",
    "2. If an expression would evaluate to an int value outside of the allowed range, an integer overflow occurs. This could result in an incorrect value within the allowed range."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Questions\n",
    "1. (int) (2.5 * 3.0)\n",
    "2. (double) 25 / 4\n",
    "3. 6 / (double) 5"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "## Mini Hacks\n",
    "- Complete all uncompleted code segments\n",
    "- Answer all questions in the code\n",
    "- complete the activities in the lesson blogs\n",
    "- will be scaled to 0.2 depending on the completion of your code\n",
    "\n",
    "## Main Hack\n",
    "- Use topics from 3 out of 4 of the Units\n",
    "- It has to be a 2 part style question, A and B\n",
    "- Will Be graded out of 4 points\n",
    "- Write a scoring sheet for what you have done out six points\n",
    "- Your real grade for the assigment will be based of two things\n",
    "- How creative, unique, cool your question and code is\n",
    "- Did you acheive 4/4 points for your code\n",
    "- That will be scaled to 0.8 of 1 for all your hacks\n",
    "\n",
    "## Example FRQ 0.65\n",
    "### Question:\n",
    "Winner of the game is represented by gameWin. Player 1 score is represented by int variable x, and Player 2 score is represented by int variable y\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class Game {\n",
    "    int x = 0;\n",
    "    int y = 0;\n",
    "\n",
    "    boolean xGameWin = false;\n",
    "    boolean yGameWin = false;\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# PART A\n",
    "write a method gameWinchange that checks who wins"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class Game {\n",
    "    int x = 0;\n",
    "    int y = 0;\n",
    "\n",
    "    boolean XgameWin = false;\n",
    "    boolean YgameWin = false;\n",
    "\n",
    "    public void gameWinchange(boolean X, boolean Y) {\n",
    "        //insert code here\n",
    "        if (X == true) {\n",
    "            UpdateScore(x,y);\n",
    "            X = true;\n",
    "        } else {\n",
    "            UpdateScore(y,x);\n",
    "            Y = true;\n",
    "        }\n",
    "    }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Part B\n",
    "Write a method to update score for Player 1 and Player 2, The player that wins gain a point, the player that loses minus a point\n",
    "If a player hits 10 points, reset values"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "vscode": {
     "languageId": "java"
    }
   },
   "outputs": [],
   "source": [
    "public class Game {\n",
    "    \n",
    "    //pretend previous method is above\n",
    "\n",
    "    public int UpdateScore(int Wscore, int Lscore) {\n",
    "        wScore += 1;\n",
    "        lScore -= 1;\n",
    "\n",
    "        if (wScore == 10) {\n",
    "            wScore = 0;\n",
    "            lScore = 0;\n",
    "        }\n",
    "        if (lScore == 10) {\n",
    "            wScore = 0;\n",
    "            lScore = 0;\n",
    "        }\n",
    "    }\n",
    "}"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Grading\n",
    "## 1/1 Point for correctly changing the boolean in Part A\n",
    "## 1/1 Point for using Compound Assigment Operators in Part B\n",
    "## 1/1 Point for Values reseting when one hits 10 points\n",
    "## 1/1 Point for Passing Arguments through Part A and B"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Java",
   "language": "java",
   "name": "java"
  },
  "language_info": {
   "codemirror_mode": "java",
   "file_extension": ".jshell",
   "mimetype": "text/x-java-source",
   "name": "Java",
   "pygments_lexer": "java",
   "version": "20+36-2344"
  },
  "orig_nbformat": 4
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
